(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('tslib'), require('react'), require('tinycolor2')) :
  typeof define === 'function' && define.amd ? define(['exports', 'tslib', 'react', 'tinycolor2'], factory) :
  (factory((global.VericusSlateKitHighlightTextRenderer = {}),global.TSLib,global.React,global.TinyColor));
}(this, (function (exports,tslib_1,React,tinycolor) { 'use strict';

  tinycolor = tinycolor && tinycolor.hasOwnProperty('default') ? tinycolor['default'] : tinycolor;

  var defaultStyle = {
      textDecoration: "inherit",
      textDecorationColor: "inherit"
  };
  function createRenderMark(opt) {
      var type = opt.type, dataField = opt.data, styleFields = opt.styles, alpha = opt.alpha;
      return function (props) {
          if (props.mark.type === type) {
              var children = props.children, attributes = props.attributes, data = props.mark.data;
              var style = (attributes || { style: {} }).style;
              var color_1 = tinycolor(data.get(dataField));
              style = tslib_1.__assign({}, defaultStyle, style, { textDecoration: "inherit", decorationStyle: "initial" }, styleFields.reduce(function (acc, styleField) {
                  var _a;
                  return (tslib_1.__assign({}, acc, (_a = {}, _a[styleField] = color_1.setAlpha(alpha).toRgbString(), _a)));
              }, {}));
              return (React.createElement("span", tslib_1.__assign({}, attributes, { style: style }), children));
          }
          return undefined;
      };
  }

  function createRenderer(opts) {
      return {
          renderMark: createRenderMark(opts)
      };
  }

  exports.createRenderer = createRenderer;
  exports.default = createRenderer;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=slate-kit-highlight-text-renderer.js.map
