import { __assign } from 'tslib';
import { createElement } from 'react';
import tinycolor from 'tinycolor2';

var defaultStyle = {
    textDecoration: "inherit",
    textDecorationColor: "inherit"
};
function createRenderMark(opt) {
    var type = opt.type, dataField = opt.data, styleFields = opt.styles, alpha = opt.alpha;
    return function (props) {
        if (props.mark.type === type) {
            var children = props.children, attributes = props.attributes, data = props.mark.data;
            var style = (attributes || { style: {} }).style;
            var color_1 = tinycolor(data.get(dataField));
            style = __assign({}, defaultStyle, style, { textDecoration: "inherit", decorationStyle: "initial" }, styleFields.reduce(function (acc, styleField) {
                var _a;
                return (__assign({}, acc, (_a = {}, _a[styleField] = color_1.setAlpha(alpha).toRgbString(), _a)));
            }, {}));
            return (createElement("span", __assign({}, attributes, { style: style }), children));
        }
        return undefined;
    };
}

function createRenderer(opts) {
    return {
        renderMark: createRenderMark(opts)
    };
}

export default createRenderer;
export { createRenderer };
//# sourceMappingURL=slate-kit-highlight-text-renderer.es.js.map
