"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = tslib_1.__importStar(require("react"));
var tinycolor2_1 = tslib_1.__importDefault(require("tinycolor2"));
var defaultStyle = {
    textDecoration: "inherit",
    textDecorationColor: "inherit"
};
function createRenderMark(opt) {
    var type = opt.type, dataField = opt.data, styleFields = opt.styles, alpha = opt.alpha;
    return function (props) {
        if (props.mark.type === type) {
            var children = props.children, attributes = props.attributes, data = props.mark.data;
            var style = (attributes || { style: {} }).style;
            var color_1 = tinycolor2_1.default(data.get(dataField));
            style = tslib_1.__assign({}, defaultStyle, style, { textDecoration: "inherit", decorationStyle: "initial" }, styleFields.reduce(function (acc, styleField) {
                var _a;
                return (tslib_1.__assign({}, acc, (_a = {}, _a[styleField] = color_1.setAlpha(alpha).toRgbString(), _a)));
            }, {}));
            return (React.createElement("span", tslib_1.__assign({}, attributes, { style: style }), children));
        }
        return undefined;
    };
}
exports.default = createRenderMark;
//# sourceMappingURL=renderMark.js.map